/************************************************************************************/
/*  Program name CAPPOEXT_PURCHASE_ORDER_DISTRIBUTION.sql                           */
/*  Creater:  Kenny, Leung (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 17 Jan 2006, Kenny Leung         First created                               */
/************************************************************************************/

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;s
alter session set nls_date_format='YYYYMMDD HH24:MI:SS';

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPPOEXT_PURCHASE_ORDER_DISTRIBUTION';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPPO_PURCHASE_ORDER_DISTRIBUTION.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		PHA.*
	FROM
		PO_DISTRIBUTIONS_ALL		PHA,
		HR_ALL_ORGANIZATION_UNITS	HRO
	WHERE	PHA.ORG_ID	=	HRO.ORGANIZATION_ID
	AND		SUBSTR(HRO.NAME,4,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	SUBSTR(UPPER('&1'), -4);

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
        
        lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
        
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
                    C1.PO_DISTRIBUTION_ID           ||CHR(9)||
                    C1.LAST_UPDATE_DATE             ||CHR(9)||
                    C1.LAST_UPDATED_BY              ||CHR(9)||
                    C1.PO_HEADER_ID                 ||CHR(9)||
                    C1.PO_LINE_ID                   ||CHR(9)||
                    C1.LINE_LOCATION_ID             ||CHR(9)||
                    C1.SET_OF_BOOKS_ID              ||CHR(9)||
                    C1.CODE_COMBINATION_ID          ||CHR(9)||
                    C1.QUANTITY_ORDERED             ||CHR(9)||
                    C1.LAST_UPDATE_LOGIN            ||CHR(9)||
                    C1.CREATION_DATE                ||CHR(9)||
                    C1.CREATED_BY                   ||CHR(9)||
                    C1.PO_RELEASE_ID                ||CHR(9)||
                    C1.QUANTITY_DELIVERED           ||CHR(9)||
                    C1.QUANTITY_BILLED              ||CHR(9)||
                    C1.QUANTITY_CANCELLED           ||CHR(9)||
                    C1.REQ_HEADER_REFERENCE_NUM     ||CHR(9)||
                    C1.REQ_LINE_REFERENCE_NUM       ||CHR(9)||
                    C1.REQ_DISTRIBUTION_ID          ||CHR(9)||
                    C1.DELIVER_TO_LOCATION_ID       ||CHR(9)||
                    C1.DELIVER_TO_PERSON_ID         ||CHR(9)||
                    C1.RATE_DATE                    ||CHR(9)||
                    C1.RATE                         ||CHR(9)||
                    C1.AMOUNT_BILLED                ||CHR(9)||
                    C1.ACCRUED_FLAG                 ||CHR(9)||
                    C1.ENCUMBERED_FLAG              ||CHR(9)||
                    C1.ENCUMBERED_AMOUNT            ||CHR(9)||
                    C1.UNENCUMBERED_QUANTITY        ||CHR(9)||
                    C1.UNENCUMBERED_AMOUNT          ||CHR(9)||
                    C1.FAILED_FUNDS_LOOKUP_CODE     ||CHR(9)||
                    C1.GL_ENCUMBERED_DATE           ||CHR(9)||
                    C1.GL_ENCUMBERED_PERIOD_NAME    ||CHR(9)||
                    C1.GL_CANCELLED_DATE            ||CHR(9)||
                    C1.DESTINATION_TYPE_CODE        ||CHR(9)||
                    C1.DESTINATION_ORGANIZATION_ID  ||CHR(9)||
                    C1.DESTINATION_SUBINVENTORY     ||CHR(9)||
                    C1.ATTRIBUTE_CATEGORY           ||CHR(9)||
                    C1.ATTRIBUTE1                   ||CHR(9)||
                    C1.ATTRIBUTE2                   ||CHR(9)||
                    C1.ATTRIBUTE3                   ||CHR(9)||
                    C1.ATTRIBUTE4                   ||CHR(9)||
                    C1.ATTRIBUTE5                   ||CHR(9)||
                    C1.ATTRIBUTE6                   ||CHR(9)||
                    C1.ATTRIBUTE7                   ||CHR(9)||
                    C1.ATTRIBUTE8                   ||CHR(9)||
                    C1.ATTRIBUTE9                   ||CHR(9)||
                    C1.ATTRIBUTE10                  ||CHR(9)||
                    C1.ATTRIBUTE11                  ||CHR(9)||
                    C1.ATTRIBUTE12                  ||CHR(9)||
                    C1.ATTRIBUTE13                  ||CHR(9)||
                    C1.ATTRIBUTE14                  ||CHR(9)||
                    C1.ATTRIBUTE15                  ||CHR(9)||
                    C1.WIP_ENTITY_ID                ||CHR(9)||
                    C1.WIP_OPERATION_SEQ_NUM        ||CHR(9)||
                    C1.WIP_RESOURCE_SEQ_NUM         ||CHR(9)||
                    C1.WIP_REPETITIVE_SCHEDULE_ID   ||CHR(9)||
                    C1.WIP_LINE_ID                  ||CHR(9)||
                    C1.BOM_RESOURCE_ID              ||CHR(9)||
                    C1.BUDGET_ACCOUNT_ID            ||CHR(9)||
                    C1.ACCRUAL_ACCOUNT_ID           ||CHR(9)||
                    C1.VARIANCE_ACCOUNT_ID          ||CHR(9)||
                    C1.PREVENT_ENCUMBRANCE_FLAG     ||CHR(9)||
                    C1.USSGL_TRANSACTION_CODE       ||CHR(9)||
                    C1.GOVERNMENT_CONTEXT           ||CHR(9)||
                    C1.DESTINATION_CONTEXT          ||CHR(9)||
                    C1.DISTRIBUTION_NUM             ||CHR(9)||
                    C1.SOURCE_DISTRIBUTION_ID       ||CHR(9)||
                    C1.REQUEST_ID                   ||CHR(9)||
                    C1.PROGRAM_APPLICATION_ID       ||CHR(9)||
                    C1.PROGRAM_ID                   ||CHR(9)||
                    C1.PROGRAM_UPDATE_DATE          ||CHR(9)||
                    C1.PROJECT_ID                   ||CHR(9)||
                    C1.TASK_ID                      ||CHR(9)||
                    C1.EXPENDITURE_TYPE             ||CHR(9)||
                    C1.PROJECT_ACCOUNTING_CONTEXT   ||CHR(9)||
                    C1.EXPENDITURE_ORGANIZATION_ID  ||CHR(9)||
                    C1.GL_CLOSED_DATE               ||CHR(9)||
                    C1.ACCRUE_ON_RECEIPT_FLAG       ||CHR(9)||
                    C1.EXPENDITURE_ITEM_DATE        ||CHR(9)||
                    C1.ORG_ID                       ||CHR(9)||
                    C1.KANBAN_CARD_ID               ||CHR(9)||
                    C1.AWARD_ID                     ||CHR(9)||
                    C1.MRC_RATE_DATE                ||CHR(9)||
                    C1.MRC_RATE                     ||CHR(9)||
                    C1.MRC_ENCUMBERED_AMOUNT        ||CHR(9)||
                    C1.MRC_UNENCUMBERED_AMOUNT      ||CHR(9)||
                    C1.END_ITEM_UNIT_NUMBER         ||CHR(9)||
                    C1.TAX_RECOVERY_OVERRIDE_FLAG   ||CHR(9)||
                    C1.RECOVERABLE_TAX              ||CHR(9)||
                    C1.NONRECOVERABLE_TAX           ||CHR(9)||
                    C1.RECOVERY_RATE                ||CHR(9)||
                    C1.OKE_CONTRACT_LINE_ID         ||CHR(9)||
                    C1.OKE_CONTRACT_DELIVERABLE_ID  ||CHR(9)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No PO Distributions for NGO';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/

